"""
Main interface for importexport service.

Usage::

    ```python
    from boto3.session import Session
    from mypy_boto3_importexport import (
        Client,
        ImportExportClient,
        ListJobsPaginator,
    )

    session = Session()
    client: ImportExportClient = session.client("importexport")

    list_jobs_paginator: ListJobsPaginator = client.get_paginator("list_jobs")
    ```
"""

from .client import ImportExportClient
from .paginator import ListJobsPaginator

Client = ImportExportClient

__all__ = ("Client", "ImportExportClient", "ListJobsPaginator")
